package vclipx;

import maspack.matrix.*;

class CreateExample
{
	public static void main (String[] args) 
	 {
	   double[] vertexCoords = 
	    { 1.0, 0.0, 0.0,
	      0.0, 1.0, 0.0,
	     -1.0, 0.0, 0.0,
	      0.0,-1.0, 0.0,
	      0.0, 0.0, 1.0 };
	   
	   int[][] faceIndices = 
	    { { 0, 3, 2, 1 },
	      { 4, 0, 1 },
	      { 4, 1, 2 },
	      { 4, 2, 3 },
	      { 4, 3, 0 } };

	   ConvexPolyhedron poly = new ConvexPolyhedron (vertexCoords, faceIndices);

	   PolyTree pyramid = new PolyTree ("pyramid", poly);
	   PolyTree hourglass = new PolyTree ("hourglass");

	   RigidTransform3d X = new RigidTransform3d();
	   X.setIdentity();
	   X.p.set (0, 0, -1);
	   hourglass.addComponent ("bottom", pyramid, X);

	   X.p.set (0, 0, 1);
	   X.R.setAxisAngle (1, 0, 0, Math.PI);
	   hourglass.addComponent ("top", pyramid, X);

	   hourglass.buildBoundingHull (PolyTree.OBB_HULL);
	 }
}
