package vclipx;

import vclip.*;
import maspack.matrix.*;
import java.util.HashMap;

class Test
{
	public static void main (String[] args) 
	 {
	   try
	    { HashMap library = new HashMap();
	      PolyTree.scanLibrary ("PolyTreeExamples.txt", library, true);

	      PolyTree ptree1 = (PolyTree)library.get("triangle-cube");
	      PolyTree ptree2 = (PolyTree)library.get("tetra");

	      DistanceReport drep = new DistanceReport();
	      ClosestFeaturesHT ht = new ClosestFeaturesHT();

	      RigidTransform3d T21 = new RigidTransform3d();

	      String featname1 = "f11";
	      String featname2 = "z:y";

	      Feature f1 = ptree1.poly_.findFeature (featname1);
	      Feature f2 = ptree2.poly_.findFeature (featname2);
	      if (f1 == null)
	       { System.out.println ("can't find feature " + featname1);
		 System.exit(1); 
	       }
	      if (f2 == null)
	       { System.out.println ("can't find feature " + featname2);
		 System.exit(1); 
	       }

	      ht.put (new PolyTreePair (ptree1, ptree2),
		      new FeaturePair (f1, f2));
	      
//	      T21.setRotY (Math.toRadians(45));
	      double dnom = 0.5;
	      Vector3d dir = new Vector3d (1, 0, 0);
	      dir.normalize();
	      Vector3d del = new Vector3d (1, 0, 0);
	      del.scaleAdd (0.5-dnom, dir, del);
	      T21.p.set (del.x, del.y, del.z);
	      double d = ptree1.vclip (drep, ptree2, T21, 0, ht);
	      drep.transformSecondPoints (T21);
	      System.out.println ("d=" + d);
	      ClosestPointPair cpair = drep.getClosestPair();
	      System.out.println ("pnt1=" + cpair.pnt1);
	      System.out.println ("pnt2=" + cpair.pnt2);
	      System.out.println ("feat1=" + cpair.feat1.getName());
	      System.out.println ("feat2=" + cpair.feat2.getName());
	    }
	   catch (Exception e) 
	    { e.printStackTrace();
	      System.exit(1);
	    }
	 }
}
